
% Plot ratio of function values of the FLAVIA and MPEG7 data sets.
% 
% By Wen Huang

figure(1);clf
    set(0,'defaultaxesfontsize',14, ...
       'defaultaxeslinewidth',0.7, ...
       'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
    set(0,'defaultlinemarkersize',10)
    subplot(2, 1, 1);
    Y = zeros(length(MDQNU_v), 4);
%     MDQNU_v = max(MDQNU_v, 0.00001);%%----
    
%     logindDQN = (MDQNU_v' > 0.01);
%     logindDDP2 = (((MDDP2U_v' > 0.01) + logindDQN) == 0);
%     logindDDP4 = (((MDDP4U_v' > 0.01) + logindDQN) == 0);
%     logindDDP8 = (((MDDP8U_v' > 0.01) + logindDQN) == 0);
%     logindDDP16 = (((MDDP16U_v' > 0.01) + logindDQN) == 0);
%     temp1 = MDDP2U_v' ./ MDQNU_v';
%     temp2 = MDDP4U_v' ./ MDQNU_v';
%     temp3 = MDDP8U_v' ./ MDQNU_v';
%     temp4 = MDDP16U_v' ./ MDQNU_v';
%     temp1(logindDDP2) = 1;
%     temp2(logindDDP4) = 1;
%     temp3(logindDDP8) = 1;
%     temp4(logindDDP16) = 1;
%     Y(:, 1) = temp1;%(logindDDP2);
%     Y(:, 2) = temp2;%(logindDDP4);
%     Y(:, 3) = temp3;%(logindDDP8);
%     Y(:, 4) = temp4;%(logindDDP16);
    
    Y(:, 1) = MDDP2U_v' ./ MDQNU_v';
    Y(:, 2) = MDDP4U_v' ./ MDQNU_v';
    Y(:, 3) = MDDP8U_v' ./ MDQNU_v';
    Y(:, 4) = MDDP16U_v' ./ MDQNU_v';

fprintf('MPEG7\n');
%% see the second largest values
% [vs, idxx] = max(Y);
% Y(idxx(1), 1) = 1000;
% Y(idxx(2), 2) = 1000;
% Y(idxx(3), 3) = 1000;
% Y(idxx(4), 4) = 1000;
max(Y)
sum(Y > 4)
    
    hist(Y, 0.05 : 0.1 : 5);
    xlim([0, 4]);
    title('MPEG-7');
    legend('C/L:N/2', 'C/L:N/4', 'C/L:N/8', 'C/L:N/16');
    xlabel('ratio of function values');
    ylabel('number');

    subplot(2, 1, 2);
    Y = zeros(length(FDQNU_v), 4);
%     FDQNU_v = max(FDQNU_v, 0.00001);%%----
    
    Y(:, 1) = FDDP2U_v' ./ FDQNU_v';
    Y(:, 2) = FDDP4U_v' ./ FDQNU_v';
    Y(:, 3) = FDDP8U_v' ./ FDQNU_v';
    Y(:, 4) = FDDP16U_v' ./ FDQNU_v';
fprintf('FLAVIA\n');
max(Y)
sum(Y > 4)
    hist(Y, 0.05 : 0.1 : 5);
    xlim([0, 4]);
    title('Flavia');
    legend('C/L:N/2', 'C/L:N/4', 'C/L:N/8', 'C/L:N/16');
    xlabel('ratio of function values');
    ylabel('number');

return;