
% Plot histograms of computational time of FLAVIA and MPEG7.
% and the computational time per initial condition for both data sets.
% 
% By Wen Huang


figure(1);clf
% figure(2);clf
    set(0,'defaultaxesfontsize',14, ...
       'defaultaxeslinewidth',0.7, ...
       'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
    set(0,'defaultlinemarkersize',10)
    tab = load('PaperExp3Result.txt');
    figure(1);
    Y = tab(:, 1);
%     hist(Y, 0.01 : 0.02 : 0.6);
    [nums, centers] = hist(Y, 0.01 : 0.02 : 0.6);
    ybs = 60; ybe = 850;
    size(nums)
    BarPlotBreak(centers, nums, ybs, ybe, 'Patch');
    xlim([0, 0.6]);
%     BarPlotBreak(centers, [nums; nums*1.2]', ybs, ybe, 'Patch');
    
    title('Histogram of the differences between \gamma_{CR1H} and \gamma_{LRBFGS}');
    ylabel('number');
    a = 1 / 10;
    idxset1 = find(tab(:, 1) > 1 * a & tab(:, 1) < 2 * a);
    idxset2 = find(tab(:, 1) > 2 * a & tab(:, 1) < 3 * a);
    idxset3 = find(tab(:, 1) > 3 * a & tab(:, 1) < 4 * a);
    idxset4 = find(tab(:, 1) > 4 * a & tab(:, 1) < 5 * a);
    idxset5 = find(tab(:, 1) > 5 * a & tab(:, 1) < 6 * a);
    idxset6 = find(tab(:, 1) > 6 * a);
    idxset7 = find(tab(:, 1) > 1 * a);
    [length(find(tab(:, 1) > 0 & tab(:, 1) < 1 * a)), 
        length(find(tab(:, 1) > 1 * a & tab(:, 1) < 2 * a)), 
        length(find(tab(:, 1) > 2 * a & tab(:, 1) < 3 * a)),
        length(find(tab(:, 1) > 3 * a & tab(:, 1) < 4 * a)),
        length(find(tab(:, 1) > 4 * a & tab(:, 1) < 5 * a)),
        length(find(tab(:, 1) > 5 * a & tab(:, 1) < 6 * a)),
        length(find(tab(:, 1) > 6 * a)),
        ]
%     find(tab(:, 1) > 0.5 & tab(:, 1) < 1)
    fprintf('# greater than %f is %d\n', a, length(find(tab(:, 1) > a)));
%     figure(2);
%     hist(tab(:, 2), 0: 0.5: 6);
%     idxset2 = find(tab(:, 2)>2)
    
%     BreakPlot([0, 0], [0, 0], 200, 750, 'Patch');