%f(R_x( t grad f(x))) - f(x)) / <grad f(x), t grad f(x)>
%R_x(t gf) = Project(x + t gf)
function [extrdist, intrdist] = test_Path_Straightening_4(C1, C2, isplot)

    PStimecost = 0;
    
    N = (size(C1, 2) + 1);
    C1 = Center_C(C1);   %move the graph to the center(average).   
    C1 = C1 / norm(C1);  %normalization
    
    C2 = Center_C(C2);
    C2 = C2 / norm(C2);
    C1 = [C1, C1(:, 1)];
    C2 = [C2, C2(:, 1)];
    C2(2, :) = C2(2, :) + (max(C1(2, :)) - min(C1(2, :))) / 4;
    C2(1, :) = C2(1, :) + (max(C1(2, :)) - min(C1(2, :))) / 4;
    
    %%----plot figures--------
    if(isplot)
        figure(1); clf;
    %     subplot(1, 4, 1);
        plot(C1(1, :), C1(2, :), '.b-')
        hold on
        plot(C2(1, :), C2(2, :), '.r-')
        hold on 
        legend('\beta_1','\beta_2');
        scatter(C1(1, 1), C1(2, 1), '*', 'k');   %mark the starting points.
        hold on
        scatter(C2(1, 1), C2(2, 1), '*', 'k');
        hold on
        title('curves')
        axis tight
        axis equal
        axis off
        pause(0.01);
    end
%     
%=======Item_1============ProjectToClosedCurve==========
%       C1 = C1(:,1:end-10);
%       C2 = C2(:,1:end-10);
%      figure(2); clf;
%      subplot(1, 4, 1);
%     plot(C1(1, :), C1(2, :), '.b-')
%     hold on
%     plot(C2(1, :), C2(2, :), '.r-')
%     legend('\beta_1','\beta_2');
%     scatter(C1(1, 1), C1(2, 1), '*', 'k');   %mark the starting points.
%     hold on
%     scatter(C2(1, 1), C2(2, 1), '*', 'k');
%     hold on
%     title('curves')
%     axis tight
%     axis equal
%     axis off
%     pause(0.01);
%=======Item_1============ProjectToClosedCurve==========


     [q1] = curve_to_q(C1);
     [q2] = curve_to_q(C2);
     [q1] = Item_1(q1);
     [q2] = Item_1(q2);
     
%    InnerProd_Q(q1,q1)
%    InnerProd_Q(q1,q1)
%==========test Item_2==========   
%    [q2] = Item_2(q2,q1);
%  %  size(C2)
%  %  size(C1)
%     InnerProd_Q(q1,q1)
%     InnerProd_Q(q2,q2)
%    inner = trapz(linspace(0,1,N),sum(q2.*q1))
%    inner2 = trapz(linspace(0,1,N),dot(q2,q1))
%==========test Item_2==========   
      
%==========test Item_3==========    
%              alpha = Initial_P(q1,q2,10);
%  %             Path_Plot(alpha,C2,2,'b',[73,6]);
%  %             axis xy; view([1 90]);
%  %             title('Initial Path');
%        c02 = 10*(alpha(:,:,2) - alpha(:,:,1));
%        q03 = alpha(:,:,3);
%        q02 = alpha(:,:,2);
%        q01 = alpha(:,:,1);
%       %%
%       Dalpha02 = Item_2(c02,q02);   
%       inner1 = trapz(linspace(0,1,N),sum(Dalpha02.*q02))
%       inner2 = trapz(linspace(0,1,N),sum(Dalpha02.*q01))
%       [wbar] = Item_3(Dalpha02, q02, q03);
%       inner3 = trapz(linspace(0,1,N),sum(wbar.*q03))
%==========test Item_3==========    

%==========Main Test============ 
            alpha = Initial_P(q1,q2,10);
if(isplot)
            Path_Plot(alpha,C2,2,'b',[73,6]);
            axis xy; view([1 90]);
            title('Initial Path');
end
            Dalpha = VelVector(alpha);
            %normDalpha = ComputeEnergy(Dalpha)
            [u] = CovIntegral(Dalpha,alpha);
            %[E] = ComputeEnergy(Dalpha);
            %E
            %normu = ComputeEnergy(u);
            [utilde] = BackTrans(u,alpha);
            [w] = GradVec(utilde,u);
            normgrad = ComputeEnergy(w)
            %Plot_test(alpha,w);
            [alpha_new] = PathUpdate(alpha,w);
% 
% %%             
            fig = 3;
            size(w)
            [aa,bb,cc] = size(w);
            for i = 1:cc
                temp(i) = sqrt(InnerProd_Q(w(:,:,i),w(:,:,i)));
            end 
            testnorm = max(temp);
            
       while (testnorm>1E-8  && fig<10)
            %testnorm
            alpha = alpha_new;
            Dalpha = VelVector(alpha);
            %normDalpha = ComputeEnergy(Dalpha)
            [u] = CovIntegral(Dalpha,alpha);
            %normu = ComputeEnergy(u);

            %[E] = ComputeEnergy(Dalpha);
            %E
            [utilde] = BackTrans(u,alpha);
            [w] = GradVec(utilde,u);
            normgrad = ComputeEnergy(w);
            [alpha_new] = PathUpdate(alpha,w);
      
%              Path_Plot(alpha_new,C2,fig,'b',[73,6]);
%              axis xy; view([1 90]);
%              title('Updated Path');
              
            for i = 1:cc
                temp(i) = sqrt(InnerProd_Q(w(:,:,i),w(:,:,i)));
            end 
            testnorm = max(temp);
            fig = fig + 1;
       end
if(isplot)
      Path_Plot(alpha_new,C2,3,'b',[73,6]);
      axis xy; view([1 90]);
      title('Final Path');
end
      intrdist = 0;
    for i = 1 : size(alpha_new, 3) - 1
        if(i ~= size(alpha_new, 3) - 1)
            intrdist = intrdist + acos(InnerProd_Q(alpha_new(:, :, i),alpha_new(:, :, i + 1)));
        else
            intrdist = intrdist + acos(InnerProd_Q(alpha_new(:, :, i),q2));
        end
    end
    extrdist = acos(InnerProd_Q(q1,q2));
    
    extrdist
    intrdist
% %% 
% %==========Main Test============ 
            
            
            
%------------------------rest---------------------------            
%       while (norm(reshape(w,aa*bb,cc),2)>1E-2  && fig<30)
%             norm(reshape(w,aa*bb,cc),2)
%             alpha = alpha_new;
%             Dalpha = VelVector(alpha);
%             [u] = CovIntegral(Dalpha,alpha);
%             [utilde] = BackTrans(u,alpha);
%             [w] = GradVec(utilde,u);
%             [alpha_new] = PathUpdate(alpha,w);
%       
% %             Path_Plot(alpha_new,C2,fig,'b',[73,6]);
% %             axis xy; view([1 90]);
% %             title('Updated Path');
% %             
%             fig = fig + 1;
%       end 
%==========Main Test============     
  
    
%     %% ------------test curve_to_q and q_to_curve----------------
%     [C1] = curve_to_q(C1);
%     [C2] = curve_to_q(C2);
%     [C1_new] = Item_1(C1);
%     [C2_new] = Item_1(C2);
%     [C1_new2] = Item_1(C1);
%     [C2_new2] = Item_1(C2);
%     [C1] = q_to_curve(C1_new);
%     [C2] = q_to_curve(C2_new);
%     
%     C1 = Center_C(C1);   %move the graph to the center(average).
%     
%     C1 = C1 / norm(C1);  %normalization
%     C2 = Center_C(C2);
%     C2 = C2 / norm(C2);
%     
%     C1 = ReSampleOpenCurve([C1, C1(:, 1)], N);
%     C2 = ReSampleOpenCurve([C2, C2(:, 1)], N);
%     C1b = C1(:, 1 : end - 1);
%     C2b = C2(:, 1 : end - 1);
%     C2(2, :) = C2(2, :) + (max(C1(2, :)) - min(C1(2, :))) / 4;
%     C2(1, :) = C2(1, :) + (max(C1(2, :)) - min(C1(2, :))) / 4;
% %     
%     figure(3);clf;
%     subplot(1,4,1);
%     plot(C1(1,:),C1(2,:),'.b-')
%     hold on
%     plot(C2(1,:),C2(2,:),'.r-')
%     legend('\beta_1','\beta_2');
%     scatter(C1(1, 1), C1(2, 1), '*', 'k');  
%     hold on
%     scatter(C2(1, 1), C2(2, 1), '*', 'k');
%     hold on
%     title('curves')
%     axis tight
%     axis equal
%     axis off
%     pause(0.01);

end

%% ===================Plot test====================
function [ans] = Plot_test(alpha,w) % alpha: the path, w: gradient
     [n,T,k] = size(alpha);
     t = 1E-3;
     for iter = 1:30
         temp = alpha + t*w;
         for i = 1:k
             Rx(:,:,i) = Item_1(temp(:,:,i));
         end 
         DRx = VelVector(Rx);
         Dalpha = VelVector(alpha);
         E1 = ComputeEnergy(DRx);
         E2 = ComputeEnergy(Dalpha);
         A = w; B = t*w;
         for i = 1:k
             temp0(i) = trapz(linspace(0,1,T),dot(A(:,:,i),B(:,:,i)));
         end 
         innerp = trapz(linspace(0,1,k),temp0);
         rate(iter) = (E1-E2)/innerp;
         t = t/2;
     end   
%      xaxis(10) = 1E-3;
%      for i = 9:-1:1
%          xaxis(i) = xaxis(i+1)/2;
%      end 
     figure(2)
     plot(rate);
     rate
end 
%% ===================Plot test====================




%% ==========================================================================
%%                                 Plot
%% ==========================================================================

function [X] = Initial_P(q1,q2,stp)
    theta = acos(InnerProd_Q(q1,q2));
    if theta > 0.0001
        for t = 1:stp+1
            tau = (t-1)/stp;
            X(:,:,t) = (sin((1-tau)*theta)*q1 + sin(tau*theta)*q2)/sin(theta);
            X(:,:,t) = Item_1(X(:,:,t));
            X(:,:,t) = X(:,:,t)/sqrt(InnerProd_Q(X(:,:,t),X(:,:,t)));
        end 
    else
        for t = 1:stp+1
            X(:,:,t) = q1;
        end 
    end
end 

function [X] = Initial_P_withM(q1,q2,qm,stp)
    theta = acos(InnerProd_Q(q1,qm));
    if theta > 0.0001
        for t = 1:stp+1
            tau = (t-1)/stp;
            X(:,:,t) = (sin((1-tau)*theta)*q1 + sin(tau*theta)*qm)/sin(theta);
            X(:,:,t) = Item_1(X(:,:,t));
            X(:,:,t) = X(:,:,t)/sqrt(InnerProd_Q(X(:,:,t),X(:,:,t)));
        end 
    else
        for t = 1:stp+1
            X(:,:,t) = q1;
        end 
    end 
    
    theta = acos(InnerProd_Q(qm,q2));
    if theta > 0.0001
        for t = stp+2:2*stp+1
            X(:,:,t) = X(:,:,t-2*(t-(stp+1)));
        end 
    end 
end 


function Path_Plot(alpha,p2n,fig,col,view_az_el)
    colorspecstr = ['b','m','k','r','g','b','k','m','g','r','g','b','k'];
    [n,T,k] = size(alpha);
    stp = k-1;
    if(n == 3)
        dt = 0.35;
    else
        dt = 0.3;
    end
    
    figure(fig); clf;
    
    axis ij;
    for tau = 1:stp+1
        if (tau==stp+1)
            p = p2n;
        else
            p = q_to_curve(alpha(:,:,tau));
        end
        p = Center_C(p);
        p = p / norm(p);
        
        %% plot geodesic horizontally
        ft(1,:) = p(1,:) ;
        ft(1,:) = ft(1,:)   - mean(ft(1,:)) +dt*tau;
        for i = 2:n
            ft(i,:) = p(i,:) - mean(p(i,:));
        end
        if(n == 2)
    %         plot(ft(1,:), ft(2,:),col); axis equal;   axis tight; hold on; axis equal; axis off; axis tight;
            z = plot(ft(1,:),ft(2,:),'Color',colorspecstr(tau),'LineWidth',1); axis equal; hold on;axis equal; axis off; axis tight;  
            set(z,'LineWidth',[3]);
        else
            if(n == 3)
                f1(1,:,tau) = ft(1,:);
                f1(2,:,tau) = ft(2,:);
                f1(3,:,tau) = ft(3,:);
                 plot3(ft(1,:),ft(2,:),ft(3,:),'Color',colorspecstr(tau),'LineWidth',1.5); axis equal; hold on;axis equal; axis off; axis tight;             
                view(view_az_el(1),view_az_el(2));axis on;
                set(gca,'XTickLabel','','YTickLabel','','ZTickLabel','');     % Remove the tick labels
                set(gca,'TickLength',[0 0]);                  % Remove the ticks
            end
        end
    end
    % print(gcf,'-depsc2', 'geodesic.eps');
    axis ij;
end

%% ==========================================================================
%% ==========================================================================


%% =================================Item_1===================================
%% Projection on closed curve. q \in R2*N
function [q_c] = Item_1(q)
    TOL = 1E-10;
    [n,N] = size(q);
    q_c = q;
    if (n~=2) 
        stop;
        fprintf('Data has to be in two dimensions.');
    end 
    
    q_c = q_c/sqrt(InnerProd_Q(q_c,q_c));
    for i = 1: N %calculate residual
        qnorm(i) = norm(q_c(:,i),'fro'); %Frobenius norm 
    end 
    residual(1) = trapz(linspace(0,1,N),q_c(1,:).*qnorm); 
    residual(2) = trapz(linspace(0,1,N),q_c(2,:).*qnorm); 
    iter = 0;
    while (norm(residual,2)>TOL) 
        for t = 1:N
            qnorm(t) = norm(q_c(:,t),'fro');  
            temp1 = 2*q_c(:,t)*residual(1);
            temp2 = 2*q_c(:,t)*residual(2); 
            b(:,t,1) = q_c(1,t)*q_c(:,t)/qnorm(t) + qnorm(t)*[1 0]' - temp1;
            b(:,t,2) = q_c(2,t)*q_c(:,t)/qnorm(t) + qnorm(t)*[0 1]' - temp2;
        end
        for i = 1:2
            for j = 1:2
                J(i,j) = trapz(linspace(0,1,N),sum(b(:,:,i).*b(:,:,j)));
            end 
        end 
        beta = inv(J)*(-residual');
        dq = beta(1)*b(:,:,1) + beta(2)*b(:,:,2);  %dq \in R2*N
        %update
        dq_abs = sqrt(InnerProd_Q(dq,dq));
        for t = 1:N
            q_c(:,t) = cos(dq_abs)*q_c(:,t) + sin(dq_abs)*dq(:,t)/dq_abs;
        end 
        %q_c = q_c/sqrt(InnerProd_Q(q_c,q_c));
        for i = 1: N %calculate residual
            qnorm(i) = norm(q_c(:,i),'fro'); 
        end 
        residual(1) = trapz(linspace(0,1,N),q_c(1,:).*qnorm); 
        residual(2) = trapz(linspace(0,1,N),q_c(2,:).*qnorm);         
        iter = iter + 1;
        %residual
    end
    %iter
end
%% =================================Item_1===================================
   


%% =================================Item_2===================================
%% Projecting arbitrary points in L2 into tangent space at q
function [w_c] = Item_2(w,q)
    [n,N] = size(q);
    q_c = q;
    w_c = w;
    if (n~=2) 
       stop;
       fprintf('Data has to be in two dimensions.');
    end 
    % Project w to T_q(C)
    temp = trapz(linspace(0,1,N),dot(w_c,q_c));
    w_c = w_c - temp*q_c;
    % solve for b1, b2
    for i = 1: N %calculate residual
        qnorm(i) = norm(q_c(:,i),'fro'); %Frobenius norm 
    end 
    for t = 1:N
        %qnorm(t) = norm(q_c(:,t),'fro');  
        temp1 = 2*q_c(:,t)*trapz(linspace(0,1,N),q_c(1,:).*qnorm);
        temp2 = 2*q_c(:,t)*trapz(linspace(0,1,N),q_c(2,:).*qnorm); 
        b(:,t,1) = q_c(1,t)*q_c(:,t)/qnorm(t) + qnorm(t)*[1 0]' - temp1;
        b(:,t,2) = q_c(2,t)*q_c(:,t)/qnorm(t) + qnorm(t)*[0 1]' - temp2;
    end
    %orthonormal basis of the normal space
    b01 = b(:,:,1)/sqrt(InnerProd_Q(b(:,:,1),b(:,:,1)));
    a0 = - InnerProd_Q(b(:,:,2),b01);
    b02 = b(:,:,2) + a0*b01;
    b02 = b02/sqrt(InnerProd_Q(b02,b02));
    
    % Project w into T_q(Cc)
    temp1 = trapz(linspace(0,1,N),dot(w_c,b01));
    temp2 = trapz(linspace(0,1,N),dot(w_c,b02));
    w_c = w_c - temp1*b01 - temp2*b02;
    %AAAAA = InnerProd_Q(w_c_new,w_c-w_c_new)
    %w_c = w_c/InnerProd_Q(w_c,w_c);
    %InnerProd_Q(b01,b02)
end 

%% =================================Item_2===================================


%% =================================Item_3===================================
%% Parallel Transport
function [wbar] = Item_3(w_in,q01,q02)
    [n,N] = size(q01);
    w = w_in;    q1 = q01;    q2 = q02;
    if (n~=2) 
       stop;
       fprintf('Data has to be in two dimensions.');
    end     
    % a
    temp = trapz(linspace(0,1,N),dot(w,q2));
    q = q1 + q2;
    wtilde = w - 2*temp*q*(1/InnerProd_Q(q,q));
    %trapz(linspace(0,1,N),dot(wtilde,q2))

    % b
    l = sqrt(InnerProd_Q(wtilde,wtilde));
    %l = norm(wtilde,2);
    % solve for b1, b2
    for i = 1: N 
        qnorm(i) = norm(q2(:,i),'fro'); %Frobenius norm 
    end 
    for t = 1:N
        temp1 = 2*q2(:,t)*trapz(linspace(0,1,N),q2(1,:).*qnorm);
        temp2 = 2*q2(:,t)*trapz(linspace(0,1,N),q2(2,:).*qnorm); 
        b(:,t,1) = q2(1,t)*q2(:,t)/qnorm(t) + qnorm(t)*[1 0]' - temp1;
        b(:,t,2) = q2(2,t)*q2(:,t)/qnorm(t) + qnorm(t)*[0 1]' - temp2;
    end
    b01 = b(:,:,1)/sqrt(InnerProd_Q(b(:,:,1),b(:,:,1)));
    a0 = - InnerProd_Q(b(:,:,2),b01);
    b02 = b(:,:,2) + a0*b01;
    b02 = b02/sqrt(InnerProd_Q(b02,b02));    
    % Project w into T_q(Cc)
    temp1 = trapz(linspace(0,1,N),dot(wtilde,b01));
    temp2 = trapz(linspace(0,1,N),dot(wtilde,b02));
    wbar = wtilde - temp1*b01 - temp2*b02;
    % Rescale
    if (sqrt(InnerProd_Q(wbar,wbar))>1E-12)
        wbar = wbar*l*(1/sqrt(InnerProd_Q(wbar,wbar)));
    end 
end 
%% =================================Item_3===================================

%% Compute energy
function [E] = ComputeEnergy(Dalpha)
    [n,T,k] = size(Dalpha);
    for i = 1:k
    temp(i) = trapz(linspace(0,1,T),dot(Dalpha(:,:,i),Dalpha(:,:,i)));
    end 
    E = 0.5*trapz(linspace(0,1,k),temp);
end 


%% Algorithm_11 
%% Compute dalpha/dt along alpha
function [Dalpha] = VelVector(alpha)
    [n,T,k] = size(alpha);
    stp = k-1;
    for t = 1:stp+1
        if (t ~= 1) 
            c(:,:,t) = stp*(alpha(:,:,t) - alpha(:,:,t-1));
        end 
        %Project c(tau/k) into T_alpha(M)
        if (t == 1)
            Dalpha(:,:,1) = zeros(n,T);     
        else 
            q = alpha(:,:,t);
            Dalpha(:,:,t) = Item_2(c(:,:,t),q);
        end 
    end 
    %Dalpha(:,:,1)
end 



%% Algorithm_12 
%% Compute covariant integral of dalpha/dt along alpha
function [u] = CovIntegral(Dalpha,alpha)
    [n,T,k] = size(alpha);
    u(:,:,1) = zeros(n,T);
    stp = k-1;
    for t = 2:stp+1
        ubar(:,:,t-1) = Item_3(u(:,:,t-1),alpha(:,:,t-1),alpha(:,:,t));
        u(:,:,t) = (1/stp)*Dalpha(:,:,t) + ubar(:,:,t-1);
    end 
    %Al12 = InnerProd_Q(u(:,:,k),u(:,:,k))
end 

%% Algorithm_13
%% Backward parallel transport
function [utilde] = BackTrans(u,alpha)
    [n,T,k] = size(u);
    utilde(:,:,k) = u(:,:,k);
    l = sqrt(InnerProd_Q(u(:,:,k),u(:,:,k)));
    for t = k-1:-1:1
        c(:,:,t) = Item_2(utilde(:,:,t+1),alpha(:,:,t));
        utilde(:,:,t) = l*c(:,:,t)/sqrt(InnerProd_Q(c(:,:,t),c(:,:,t)));
    end 
    %Al13 = InnerProd_Q(utilde(:,:,1),utilde(:,:,1))
    %utilde(:,:,1)
end 

%% Algorithm_14
%% Gradient vector field
function [w] = GradVec(utilde,u)
    [n,T,k] = size(u);
    w(:,:,1) = zeros(n,T);
    stp = k-1;
    for t = 2:k
        w(:,:,t) = u(:,:,t) - ((t-1)/stp)*utilde(:,:,t);
    end 
    %w(:,:,1)
end 

%% Algorithm_15
%% Path Update
function [alpha_new] = PathUpdate(alpha,w)
    [n,T,k] = size(alpha);
    eps = 1;
    for t = 1:k
        alpha_p(:,:,t) = alpha(:,:,t) - eps*w(:,:,t);
        alpha_new(:,:,t) = Item_1(alpha_p(:,:,t));
    end 
end 




%% @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
function output = shift_C(C, i)
    output = zeros(size(C));
    output(:, end - i + 1 : end) = C(:, 1 : i);
    output(:, 1 : end - i) = C(:, i + 1 : end);
    
    return;
    output = zeros(size(C));
    output(:, 1 : i) = C(:, end - i + 1 : end);
    output(:, i + 1 : end) = C(:, 1 : end - i);
end


function output = Center_C(C)
    [n, N] = size(C);
    ave = sum(C')' / N;
    output = C;
    for i = 1 : N
        output(:, i) = output(:, i) - ave;
    end
end

function output = ReSampleOpenCurve(C, NN)
    N = size(C, 2); 
    del(1) = 0;
    for i = 2 : N
        del(i) = norm(C(:, i) - C(:,i - 1));
    end
    cumdel = cumsum(del) / sum(del); 
    newdel = [0:NN-1]/(NN-1);
    output(1,:) = spline(cumdel,C(1,1:N),newdel);%
    output(2,:) = spline(cumdel,C(2,1:N),newdel);
end

function [q] = curve_to_q(p)                %SRVF
    [n,N] = size(p);                        %n dimension, N number of points
    xslope = (p(1, 2) - p(1, end - 1)) / (2 / (N - 1));   %
    yslope = (p(2, 2) - p(2, end - 1)) / (2 / (N - 1));
    pp = zeros(n, N + 2);
    pp(1, 1) = xslope;
    pp(1, end) = xslope;
    pp(2, 1) = yslope;
    pp(2, end) = yslope;
    pp(:, 2 : end - 1) = p;
    
    ppp = spline((0 : (N - 1)) / (N - 1), pp);     %spline: matlabֵ(һ߽)
    ppdp = first_deri(ppp);
    v = ppval(ppdp, (0 : (N - 1)) / (N - 1));      %y=ppval(pp,xx)ֵϣxxӦyy
    for i = 1:N
        L(i) = sqrt(norm(v(:,i),'fro'));
        if L(i) > 0.000001
            q(:,i) = v(:,i)/L(i);
        else
            q(:,i) = 0*ones(n,1);
        end
    end
    q = q/sqrt(InnerProd_Q(q,q));
end

function [p] = q_to_curve(q)
    [n,T] = size(q);
    for i = 1:T
        qnorm(i) = norm(q(:,i),'fro');  %Frobenius norm
    end
    for i = 1:n
        p(i,:) = [ cumtrapz( q(i,:).*qnorm )/(T) ] ; 
    end
end

function val = InnerProd_Q(q1,q2)  %trapezoidal rule
    [n,T] = size(q1);
    val = trapz(linspace(0,1,T),sum(q1.*q2)); %
end

function output = first_deri(ppf)
    ppf.coefs = ppf.coefs(:, 1 : 3);
    ppf.coefs(:, 1) = ppf.coefs(:, 1) * 3;
    ppf.coefs(:, 2) = ppf.coefs(:, 2) * 2;
    ppf.order = 3;
    output = ppf;
end
