function Large_Samples_Known_Gamma_LRBFGS_DP(CM, CF, idxset)
    fprintf('test for reparametrization of closed curve in elastic shape analysis.. \n');
    r = rand();
    r = floor(r * 1000000000)
    r = 1
    rand('state', r);
    randn('state', r);
    suptitlelist = '(a)(b)(c)(d)(e)(f)(g)(h)(i)(j)(k)(l)(m)(n)(o)(p)(q)(r)(s)(t)(u)(v)(w)(x)(y)(z)';
    num = 10;
    subplotnum = 2;
    
    tab = zeros(num * (70+32), 6);
    idx = 0;
    for i = 1 : 70
        for j = 1 : num
            idx = idx + 1;
            shape_idx = (i - 1) * 20 + j;
            if(nargin == 2)
                [i, j, idx]
                [tab(idx, 1), tab(idx, 2),tab(idx, 3),tab(idx, 4),tab(idx, 5),tab(idx, 6)] = OneSample(CM(:, :, shape_idx), 100, 0, idx, 0, '');
            else
                if(sum(idx == idxset))
                    [i, j, idx]
                    titleidx = find(idxset == idx);
                    if(subplotnum == 2 && length(suptitlelist) <= 26*3)
                        supT = suptitlelist(3*titleidx-2 : 3*titleidx);
                    else
                        supT = '';
                    end
                    [tab(idx, 1),tab(idx, 2), tab(idx, 3), tab(idx, 4), tab(idx, 5), tab(idx, 6)] = OneSample(CM(:, :, shape_idx), 100, 1, idx, subplotnum, supT);
                    tab(idx, 1)
                end
            end
        end
    end
%     return;
    %% for FLAVIA data set. Sepecify curves from a cluster
    Lbreaks = [0,59,122,194,267,323,385,437,496,551,616,...
    666,728,780,846,906,962,1039,1101,1162,1228,...
    1288,1343,1398,1463,1517,1569,1622,1677,1734,1798,...
    1851,1907];

    for i = 1 : 32
        for j = 1 : num
            idx = idx + 1;
            shape_idx = Lbreaks(i) + j;
            if(nargin == 2)
                [i, j, idx]
                [tab(idx, 1), tab(idx, 2), tab(idx, 3), tab(idx, 4), tab(idx, 5), tab(idx, 6)] = OneSample(CF(:, :, shape_idx), 100, 0, idx, 0, '');
            else
                if(sum(idx == idxset))
                    [i, j, idx]
                    titleidx = find(idxset == idx);;
                    if(subplotnum == 2 && length(suptitlelist) <= 26*3)
                        supT = suptitlelist(3*titleidx-2 : 3*titleidx);
                    else
                        supT = '';
                    end
                    [tab(idx, 1), tab(idx, 2), tab(idx, 3), tab(idx, 4), tab(idx, 5), tab(idx, 6)] = OneSample(CF(:, :, shape_idx), 100, 1, idx, subplotnum, supT);
                    tab(idx, 1)
                end
            end
        end
    end
    if(nargin == 2)
        dlmwrite('PaperExp3Result.txt', tab);
    end
end

function [diff_gamma, diff_O, min_f, min_fDP, RQNtimecost, DPtimecost] = OneSample(C1, N, isplot, iii, subplotnum, suptitlename)

    r = iii;
    rand('state', r);
    randn('state', r);
    
    N = (size(C1, 2)*1 + 1);
    idx = (0 : (N - 1)) / (N - 1);
    C1b = [C1, C1(:, 1)];
    C2b = C1b;
    O2 = orth(randn(2, 2));
    if(det(O2) < -0.5)
        O2(:, 2) = - O2(:, 2);
    end
    O2
    C2b = O2 * C2b;
%     a = 1;b = 5;gammatest = ((idx + a).^b - a^b) / ((1 + a)^b - a^b);
%     gammatest = ((idx - 0.5).^3 + 0.5^3) .* ((idx - 0.5).^3 - 0.5^3) .* (idx - 0.5) * 10 + idx;
%     gammatest = ((idx - 0.5).^2 + 0.5^2) .* ((idx - 0.5).^2 - 0.5^2) .* (idx - 0.5) * 8 + idx;
%     gammatest = idx .* (idx - 0.2) .* (idx - 1) .* (idx - 4 / 3) * 3 + idx;
    gammatest = sin(idx * 2 * pi) / (4 * pi) + idx; %
    
%     scatter(idx, gammatest, '.');error('asf');%%-------
    
    ppC1 = csape((0:(N-1))/(N-1), C1b, 'periodic');
    C1b = ppval(ppC1, gammatest);

    C1 = C1b';
    C2 = C2b';
    
    rotated = 1;
    isclosed = 1;
    onlyDP = 0;
    auto = 0;
    [XQNopt, swap2, QNfopts, QNcomtime] = TestElasticCurvesRO(C1, C2, 0.01, rotated, isclosed, onlyDP, 4, 'LRBFGS', auto);
    min_f = QNfopts(1);
    RQNtimecost = QNcomtime(1);
    fprintf('RQN time cost: %f, min f: %f, \n', QNcomtime(1), QNfopts(1));
%%=====================Dynamic programming=======================
    onlyDP = 1;
    [XCDopt, swap1, CDfopts, CDcomtime] = TestElasticCurvesRO(C1, C2, 0, rotated, isclosed, onlyDP, 4, '', auto);
    min_fDP = CDfopts(1);
    DPtimecost = CDcomtime(1);
    fprintf('CD1H time cost: %f, min f: %f, \n', CDcomtime(1), CDfopts(1));

%%==================plot gamma function=================================

    CDm = XCDopt(end)
    O = XCDopt(end - 4 : end - 1);
    CDO = reshape(O, 2, 2);
    CDgamma = XCDopt(1 : end - 5);
    n = size(C1, 1);
    if(swap1)
        CDgamma = invertGamma(CDgamma);
        CDO = CDO';
        CDm = n - CDm;
    end
    CDO
    
    QNm = XQNopt(end)
    O = XQNopt(end - 4 : end - 1);
    QNO = reshape(O, 2, 2);
    QNgamma = XQNopt(1 : end - 5);
    if(swap2)
        QNgamma = invertGamma(QNgamma);
        QNO = QNO';
        QNm = n - QNm;
    end
    QNO
    
    gammaCD = mod(CDgamma + CDm, 1);
    gammaQN = mod(QNgamma + QNm, 1);
% figure(10000); clf%%----
% scatter(1:length(gammaCD), gammaCD, 'r');
% hold on
% scatter(1:length(gammaQN), gammaQN, 'b');%%---
    for i = 1 : length(gammaCD)
        diff_gammaV = abs(gammaCD - gammaQN);
    end
    diff_gamma = trapz((0 : N - 1) / (N - 1), diff_gammaV);
    
    diff_O = norm(QNO - CDO, 'fro');
    fprintf('diff_gamma:%f, diff_O:%f\n', diff_gamma, diff_O);
    
%%==================plot matching graph============================
if(isplot)
        figure(iii);clf
        subplot(1, 2, 2);
    plot_matching_curves(C1', (C2 * CDO')', gammaCD, 1, 'CD1H');
    
    subplot(1, 2, 1);
    plot_matching_curves(C1', (C2 * QNO')', gammaQN, 1, 'LRBFGS');
    
    if(subplotnum==2)
        suptitle(suptitlename);
    else
        suptitle(num2str(iii));
    end
    fprintf('fQN:%f, fDP:%f\n', min_f, min_fDP);
    fprintf('tQN:%f, tDP:%f\n', RQNtimecost, DPtimecost);
end
% norm(grad_gamma2pi - DPgamma * (2 * pi))
end

function plot_matching_curves(C1, C2, gamma, L, titlestr)
    C1 = Center_C(C1')';
    C1 = C1 / norm(C1);
    C2 = Center_C(C2')';
    C2 = C2 / norm(C2);
    C2(1, :) = C2(1, :) - min(C2(1, :)) + max(C1(1, :)) + 0.02;

    N = size(C1, 2);
    color_hsv = hsv(N);
    plot(C1(1, :), C1(2, :), 'b')
    hold on
    plot(C2(1, :), C2(2, :), 'r')
    title(titlestr)
    axis equal
    axis tight
    ppC2 = spline((0:(N-1))/(N-1) * L, C2);
    for i = 1 : N
        VV = ppval(ppC2, gamma(i));
        scatter([C1(1, i), VV(1)], [C1(2, i), VV(2)], 10, [color_hsv(i, :)]);
%         plot([C1(1, i), VV(1)], [C1(2, i), VV(2)], 'k');
        if(i == 1)
            scatter([C1(1, i), VV(1)], [C1(2, i), VV(2)], '*', 'k');
        end
    end
    axis off
end

function output = Center_C(C)
    C = C';
    [n, N] = size(C);
    ave = sum(C')' / N;
    output = C;
    for i = 1 : N
        output(:, i) = output(:, i) - ave;
    end
    output = output';
end

function gamI = invertGamma(gam)
    N = length(gam);
    x = [0:(N-1)]/(N-1);
    gamI = interp1(gam,x,x,'linear');
end
