function TestShiftBreakpoints(CM, CF, idxset)

    fprintf('test for reparametrization of closed curve in elastic shape analysis.. \n');
    r = rand();
    r = floor(r * 1000000000)
    r = 1
    rand('state', r);
    randn('state', r);
    suptitlelist = '(a)(b)(c)(d)(e)(f)(g)(h)(i)(j)(k)(l)(m)(n)(o)(p)(q)(r)(s)(t)(u)(v)(w)(x)(y)(z)';
    num = 10;
    sflist = [0, 1, 2, 4, 8];
    
    global numargin;
    numargin = nargin;
    
    tabLRBFGS = zeros(num * (70+32), length(sflist));
    tabCR1H = zeros(num * (70+32), length(sflist));
    
    subplotnum = 1;
    
    idx = 0;
    for i = 1 : 70
        for j = 1 : num
            idx = idx + 1;
            shape_idx = (i - 1) * 20 + j;
            if(nargin == 2)
                [i, j, idx]
                for k = 1 : length(sflist)
                    min_f2 = 10;
                    min_f1 = 10;
                    min_fDP1 = 10;
                    min_fDP2 = 10;
                    [diff_gamma, diff_O, min_f1, min_fDP1, RQNtimecost, DPtimecost] = OneSample(CM(:, :, shape_idx), ...
                        100, 0, idx, 0, '', sflist(k));
                    [diff_gamma, diff_O, min_f2, min_fDP2, RQNtimecost, DPtimecost] = OneSample(CM(:, :, shape_idx), ...
                        100, 0, idx + 10000, 0, '', 100 - sflist(k));
                    tabLRBFGS(idx, k) = min(min_f1, min_f2);
                    tabCR1H(idx, k) = min(min_fDP1, min_fDP2);
                end
                tabLRBFGS(idx, :)
                tabCR1H(idx, :)
            else
                if(sum(idx == idxset))
                    [i, j, idx]
                    for k = 1 : length(sflist)
                        min_f2 = 10;
                        min_f1 = 10;
                        min_fDP1 = 10;
                        min_fDP2 = 10;
                        titleidx = find(idxset == idx);;
                        [diff_gamma, diff_O, min_f1, min_fDP1, RQNtimecost, DPtimecost] = OneSample(CM(:, :, shape_idx), ...
                            100, 0, idx, 4, suptitlelist(3*titleidx-2 : 3*titleidx), sflist(k));
                        [diff_gamma, diff_O, min_f2, min_fDP2, RQNtimecost, DPtimecost] = OneSample(CM(:, :, shape_idx), ...
                            100, 0, idx + 10000, 4, suptitlelist(3*titleidx-2 : 3*titleidx), 100 - sflist(k));
                        tabLRBFGS(idx, k) = min(min_f1, min_f2);
                        tabCR1H(idx, k) = min(min_fDP1, min_fDP2);
                    end
                    tabLRBFGS(idx, :)
                    tabCR1H(idx, :)
                end
            end
        end
    end
%     return;
    %% for FLAVIA data set. Sepecify curves from a cluster
    Lbreaks = [0,59,122,194,267,323,385,437,496,551,616,...
    666,728,780,846,906,962,1039,1101,1162,1228,...
    1288,1343,1398,1463,1517,1569,1622,1677,1734,1798,...
    1851,1907];

    for i = 1 : 32
        for j = 1 : num
            idx = idx + 1;
            shape_idx = Lbreaks(i) + j;
            if(nargin == 2)
                [i, j, idx]
                for k = 1 : length(sflist)
                    min_f2 = 10;
                    min_f1 = 10;
                    min_fDP1 = 10;
                    min_fDP2 = 10;
                    h = 'here1'
                    [diff_gamma, diff_O, min_f1, min_fDP1, RQNtimecost, DPtimecost] = OneSample(CF(:, :, shape_idx), ...
                        100, 0, idx, 0, '', sflist(k));
                    h = 'here2'
                    [diff_gamma, diff_O, min_f2, min_fDP2, RQNtimecost, DPtimecost] = OneSample(CF(:, :, shape_idx), ...
                        100, 0, idx + 10000, 0, '', 100 - sflist(k));
                    tabLRBFGS(idx, k) = min(min_f1, min_f2);
                    tabCR1H(idx, k) = min(min_fDP1, min_fDP2);
                end
                tabLRBFGS(idx, :);
                tabCR1H(idx, :);
            else
                if(sum(idx == idxset))
                    [i, j, idx]
                    for k = 1 : length(sflist)
                        min_f2 = 10;
                        min_f1 = 10;
                        min_fDP1 = 10;
                        min_fDP2 = 10;
                        titleidx = find(idxset == idx);;
                        [diff_gamma, diff_O, min_f1, min_fDP1, RQNtimecost, DPtimecost] = OneSample(CF(:, :, shape_idx), ...
                            100, 0, idx, 4, suptitlelist(3*titleidx-2 : 3*titleidx), sflist(k));
                        [diff_gamma, diff_O, min_f2, min_fDP2, RQNtimecost, DPtimecost] = OneSample(CF(:, :, shape_idx), ...
                            100, 0, idx + 10000, 4, suptitlelist(3*titleidx-2 : 3*titleidx), 100 - sflist(k));
                        tabLRBFGS(idx, k) = min(min_f1, min_f2);
                        tabCR1H(idx, k) = min(min_fDP1, min_fDP2);
                    end
                    tabLRBFGS(idx, :);
                    tabCR1H(idx, :);
                end
            end
        end
    end
    if(nargin == 2)
        dlmwrite('PaperExp4LRBFGS_f.txt', tabLRBFGS);
        dlmwrite('PaperExp4CD1H_f.txt', tabCR1H);
    end
end

function [diff_gamma, diff_O, min_f, min_fDP, RQNtimecost, DPtimecost] = OneSample(C1, N, isplot, iii, subplotnum, suptitlename, shift_value)%(C1, N, isplot, iii, subplotnum, suptitlename)
isplot = 1;%%---
    if(iii < 10000)
        r = iii;
    else
        r = iii - 10000;
    end
iii
r
    rand('state', r);
    randn('state', r);
    randshift = round(rand() * 100)
    C1 = shift_C(C1, randshift);
    
    N = (size(C1, 2)*1 + 1);
    O2 = orth(randn(2, 2));
    if(det(O2) < -0.5)
        O2(:, 2) = - O2(:, 2);
    end
    C1b = [C1, C1(:, 1)];
    C2b = O2 * C1;
    C2b = shift_C(C2b, shift_value);
    C2b = [C2b, C2b(:, 1)];
    C1 = C1b';
    C2 = C2b';
    global numargin;
    if(numargin == 3)
        h1 = figure(iii);clf
        subplot(1, 3, 1);
        plot_matching_curves(C1', C2', (0:(N-1))/(N-1), 1, 'original matching');
    end
    
    rotated = 1;
    isclosed = 1;
    onlyDP = 0;
    auto = 0;
    [XQNopt, swap2, QNfopts, QNcomtime] = TestElasticCurvesRO(C1, C2, 0.01, rotated, isclosed, onlyDP, 4, 'LRBFGS', auto);
    min_f = QNfopts(1);
    RQNtimecost = QNcomtime(1);
    fprintf('RQN time cost: %f, min f: %f, \n', QNcomtime(1), QNfopts(1));
%%=====================Dynamic programming=======================
    onlyDP = 1;
    [XCDopt, swap1, CDfopts, CDcomtime] = TestElasticCurvesRO(C1, C2, 0, rotated, isclosed, onlyDP, 4, '', auto);
    min_fDP = CDfopts(1);
    DPtimecost = CDcomtime(1);
    fprintf('CD1H time cost: %f, min f: %f, \n', CDcomtime(1), CDfopts(1));

%%==================plot gamma function=================================

    CDm = XCDopt(end)
    O = XCDopt(end - 4 : end - 1);
    CDO = reshape(O, 2, 2);
    CDgamma = XCDopt(1 : end - 5);
    n = size(C1, 1);
    if(swap1)
        CDgamma = invertGamma(CDgamma);
        CDO = CDO';
        CDm = n - CDm;
    end
    CDO
    
    
    QNm = XQNopt(end)
    O = XQNopt(end - 4 : end - 1);
    QNO = reshape(O, 2, 2);
    QNgamma = XQNopt(1 : end - 5);
    if(swap2)
        QNgamma = invertGamma(QNgamma);
        QNO = QNO';
        QNm = n - QNm;
    end
    QNO
    
    gammaCD = mod(CDgamma + CDm, 1);
    gammaQN = mod(QNgamma + QNm, 1);

    for i = 1 : length(gammaCD)
        diff_gammaV = abs(gammaCD - gammaQN);
    end
    diff_gamma = trapz((0 : N - 1) / (N - 1), diff_gammaV);
    
    diff_O = norm(QNO - CDO, 'fro');
    fprintf('diff_gamma:%f, diff_O:%f\n', diff_gamma, diff_O);
    
%%==================plot matching graph============================

    if(numargin == 3)
        figure(iii);
        subplot(1, 3, 2);
        plot_matching_curves(C1', (C2 * CDO')', gammaCD, 1, 'CD1H');
        subplot(1, 3, 3);
        plot_matching_curves(C1', (C2 * QNO')', gammaQN, 1, 'LRBFGS');
    end
    fprintf('fQN:%e, fDP:%e\n', min_f, min_fDP);
    fprintf('tQN:%f, tDP:%f\n', RQNtimecost, DPtimecost);
end

function plot_matching_curves(C1, C2, gamma, L, titlestr)
    C1 = Center_C(C1')';
    C1 = C1 / norm(C1);
    C2 = Center_C(C2')';
    C2 = C2 / norm(C2);
    C2(1, :) = C2(1, :) - min(C2(1, :)) + max(C1(1, :)) + 0.02;

    N = size(C1, 2);
    color_hsv = hsv(N);
    plot(C1(1, :), C1(2, :), 'b')
    hold on
    plot(C2(1, :), C2(2, :), 'r')
    title(titlestr)
    axis equal
    axis tight
    ppC2 = spline((0:(N-1))/(N-1) * L, C2);
    for i = 1 : N
        VV = ppval(ppC2, gamma(i));
        scatter([C1(1, i), VV(1)], [C1(2, i), VV(2)], 10, [color_hsv(i, :)]);
%         plot([C1(1, i), VV(1)], [C1(2, i), VV(2)], 'k');
        if(i == 1)
            scatter([C1(1, i), VV(1)], [C1(2, i), VV(2)], '*', 'k');
        end
    end
    axis off
end

function output = shift_C(C, i)
    output = zeros(size(C));
    output(:, end - i + 1 : end) = C(:, 1 : i);
    output(:, 1 : end - i) = C(:, i + 1 : end);
    
    return;
    output = zeros(size(C));
    output(:, 1 : i) = C(:, end - i + 1 : end);
    output(:, i + 1 : end) = C(:, 1 : end - i);
end

function output = Center_C(C)
    C = C';
    [n, N] = size(C);
    ave = sum(C')' / N;
    output = C;
    for i = 1 : N
        output(:, i) = output(:, i) - ave;
    end
    output = output';
end

function gamI = invertGamma(gam)
    N = length(gam);
    x = [0:(N-1)]/(N-1);
    gamI = interp1(gam,x,x,'linear');
end
