function RQN_DP_time_for_Analysis6(setC1, setC2)
% Obtain computational time of DP and LRBFGS for two curves. The number of
% points on the curves are from 50 to 2000.
% 
% By Wen Huang

    spani = 50: 10 : 400
    spani = [spani, 450:50:1000];
    num = length(spani);
    RQNt = zeros(num, 1);
    DPt = zeros(num, 1);
    ind = 1;
    repn = 1;
    for i = spani
        for j = 1 : repn
            [RQNt0, DPt0] = test(setC1{ind}, setC2{ind});
            RQNt(ind) = RQNt(ind) + RQNt0;
            DPt(ind) = DPt(ind) + DPt0;
        end
        RQNt(ind) = RQNt(ind) / repn;
        DPt(ind) = DPt(ind) / repn;
        ind = ind + 1;
%         if(i == 1000)
%             dlmwrite('PaperExp6RQNt1000.txt', RQNt);
%             dlmwrite('PaperExp6DPt1000.txt', DPt);
%         end
%         if(i == 1500)
%             dlmwrite('PaperExp6RQNt1500.txt', RQNt);
%             dlmwrite('PaperExp6DPt1500.txt', DPt);
%         end
%         if(i == 1600)
%             dlmwrite('PaperExp6RQNt1600.txt', RQNt);
%             dlmwrite('PaperExp6DPt1600.txt', DPt);
%         end
    end
    dlmwrite('PaperExp6RQNt1000.txt', RQNt);
    dlmwrite('PaperExp6DPt1000.txt', DPt);
end
function [RQNtime, CD1Htime] = test(C1, C2)
    C1 = C1';
    C2 = C2';

    C1 = [C1; C1(1, :)];
    C2 = [C2; C2(1, :)];

%%=================== CD method=============================
    rotated = 1;
    isclosed = 1;
    onlyDP = 1;
    auto = 1;
    CD1Htime = 0;
    if(size(C1, 1) < 310)
        [XCDopt, swap1, CDfopts, CDcomtime] = TestElasticCurvesRO(C1, C2, 0, rotated, isclosed, onlyDP, 4, '', auto);
        CD1Htime = CDcomtime(1);
    end
    onlyDP = 0;
    [XQNopt, swap2, QNfopts, QNcomtime] = TestElasticCurvesRO(C1, C2, 0.01, rotated, isclosed, onlyDP, 4, 'LRBFGS', auto);
    RQNtime = QNcomtime(1);
end
