function PlotSoftICA(N)
num = 1000;
lr = 4;
lb = 4;

RBFGSARMIJO = load(['RBFGSARMIJO' num2str(N)]);
RBFGSWOLFE = load(['RBFGSWOLFE' num2str(N)]);
RBFGSARMIJO = reshape(RBFGSARMIJO, num, lr, 8);
RBFGSWOLFE = reshape(RBFGSWOLFE, num, lb, 8);

figure(1);clf
titles = {'iter', 'nf', 'ng', 'nR', 'nV', 'nVp', 'nH', 't'};
for i = 1 : 8
    subplot(2, 4, i);
    hist(RBFGSARMIJO(:, :, i));
    legend('1/2', '1/4', '1/16', '1/64');
    title(titles{i});
    ave = sum(RBFGSARMIJO(:, :, i)) / num;
    xlabel({num2str(ave(1));
        num2str(ave(2));
        num2str(ave(3));
        num2str(ave(4));});
end
[v, idxA] = min(ave);


figure(2);clf
for i = 1 : 8
    subplot(2, 4, i);
    hist(RBFGSWOLFE(:, :, i));
    legend('1/2', '1/4', '1/16', '1/64');
    title(titles{i});
    ave = sum(RBFGSWOLFE(:, :, i)) / num;
    xlabel({num2str(ave(1));
        num2str(ave(2));
        num2str(ave(3));
        num2str(ave(4));});
end
[v, idxW] = min(ave);

figure(3);clf
lds = {'1/2', '1/4', '1/16', '1/64'};
for i = 1 : 8
    subplot(2, 4, i);
    TAB = [RBFGSARMIJO(:, idxA, i), RBFGSWOLFE(:, idxW, i)];
    hist(TAB);
    legend(['A:' lds{idxA}], ['W:' lds{idxW}]);
    title(titles{i});
    ave = sum(TAB) / num;
    xlabel({num2str(ave(1));
        num2str(ave(2));});
end

end

