function SoftICALRBFGSLS_plln(method, paramset, HasHHR, N)
%% paramset: 1, qf +VT Parallelization
%%         : 2, constructed R + VT Parallelization
%% Has HHR : Use HHR to gaurantee locking condition or not

%% ARMIJO
num = 1;%1000;
LS_ratios = [1/64];
ns = [400, 800, 800, 1600];
ps = [2, 2, 4, 4];
ns = [1600];%%---
ps = [4];%%----

tab = zeros(num, length(ns), 8);
for k = 1 : length(ns)
    clearvars -except num LS_ratios k tab N n p paramset method HasHHR ns ps
    for j = 1 : num
        j
        randn('state', j);
        Cs = randn(ns(k), ns(k), N);
        for i = 1 : N
            Cs(:, :, i) = diag(ns(k) : -1 : 1) + 0.1 * (Cs(:, :, i) + Cs(:, :, i)');
        end
        X = orth(randn(ns(k), ps(k)));
        if(paramset == 2)
            Xp = null(X');
            X = [X, Xp];
        end
        clear('SolverParams');
        SolverParams.method = method;
        SolverParams.LS_ratio1 = LS_ratios(1);
        SolverParams.LS_ratio2 = 1 - LS_ratios(1);
        SolverParams.IsCheckParams = 1;
        SolverParams.Max_Iteration = 10000;
        SolverParams.DEBUG = 2;
        SolverParams.OutputGap = 10;
        if(paramset == 1)
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, ns(k), ps(k), HasHHR, 1, SolverParams);
        else
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, ns(k), ps(k), 0, 2, SolverParams);
        end
        % [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funSeries, gradSeries, timeSeries] = TestStieSoftICA(Cs, X, SolverParams);

        tab(j, k, 1) = iter;
        tab(j, k, 2) = nf;
        tab(j, k, 3) = ng;
        tab(j, k, 4) = nR;
        tab(j, k, 5) = nV;
        tab(j, k, 6) = nVp;
        tab(j, k, 7) = nH;
        tab(j, k, 8) = ComTime;
    end
end

dlmwrite(['plln_' method 'ARMIJO' num2str(N) '_' num2str(paramset) '_' num2str(HasHHR)], tab);

LS_betas = [1-1/64];
tab = zeros(num, length(ns), 8);
if(HasHHR ~= 0 || paramset ~= 1)
%% WOLFE

for k = 1 : length(ns)
    clearvars -except num LS_betas k tab n p N paramset method HasHHR ns ps
    for j = 1 : num
        j
        randn('state', j);
        Cs = randn(ns(k), ns(k), N);
        for i = 1 : N
            Cs(:, :, i) = diag(ns(k) : -1 : 1) + 0.1 * (Cs(:, :, i) + Cs(:, :, i)');
        end
        X = orth(randn(ns(k), ps(k)));
        if(paramset == 2)
            Xp = null(X');
            X = [X, Xp];
        end
        clear('SolverParams');
        SolverParams.method = method;
        SolverParams.LS_beta = LS_betas(1);
        SolverParams.LineSearch_LS = 1;
        SolverParams.IsCheckParams = 1;
        SolverParams.Max_Iteration = 10000;
        SolverParams.DEBUG = 2;
        SolverParams.OutputGap = 10;
        if(paramset == 1)
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, ns(k), ps(k), HasHHR, 1, SolverParams);
        else
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, ns(k), ps(k), 0, 2, SolverParams);
        end
        % [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funSeries, gradSeries, timeSeries] = TestStieSoftICA(Cs, X, SolverParams);

        tab(j, k, 1) = iter;
        tab(j, k, 2) = nf;
        tab(j, k, 3) = ng;
        tab(j, k, 4) = nR;
        tab(j, k, 5) = nV;
        tab(j, k, 6) = nVp;
        tab(j, k, 7) = nH;
        tab(j, k, 8) = ComTime;
    end
end
end
dlmwrite(['plln_' method 'WOLFE' num2str(N) '_' num2str(paramset) '_' num2str(HasHHR)], tab);
end