function SoftICARBFGSLS()
%% ARMIJO
n = 12; p = 8; N = 128;

r = floor(rand() * 1000000)
% r = 795199

methods = {'RTRNewton', 'RTRSR1', 'RWRBFGS', 'RBFGS', 'LRBFGS', 'RCG', 'RSD'};
colors = {'r', 'g', 'b', 'c', 'm', 'k', 'y'};
figure(1);clf;
figure(2);clf;
for k = 1 : length(methods)
    funSeries = 0;
    gradSeries = 0;
    timeSeries = 0;
    for h = 1 : 10
        randn('state', r);
        Cs = randn(n, n, N);
        for i = 1 : N
            Cs(:, :, i) = diag(n : -1:1) + 0.1 * (Cs(:, :, i) + Cs(:, :, i)');
        end
        X = orth(randn(n, p));
        clear('SolverParams');
        SolverParams.method = methods{k};
        SolverParams.LineSearch_LS = 0;
        SolverParams.LS_ratio1 = 0.5;
        SolverParams.LS_ratio2 = 0.5;
%         if(strcmp(methods{k}, 'RCG'))
            SolverParams.LineSearch_LS = 0;
            SolverParams.LS_beta = 0.5;
%         end
        if(strcmp(methods{k}, 'RBFGS') || strcmp(methods{k}, 'RWRBFGS'))
            SolverParams.isconvex = 1;
        end
        
        SolverParams.OutputGap = 1000;
        SolverParams.IsCheckParams = 1;
        SolverParams.DEBUG = 2;
        [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funSeriestmp, gradSeriestmp, timeSeriestmp] = TestStieSoftICA(Cs, X, n, p, 0, 1, SolverParams);
        % [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funSeries, gradSeries, timeSeries] = TestStieSoftICA(Cs, X, SolverParams);
        funSeries = funSeries + funSeriestmp;
        gradSeries = gradSeries + gradSeriestmp;
        timeSeries = timeSeries + timeSeriestmp;
    end
    figure(1);
    semilogy(timeSeries / 100, gradSeries / 100, ['.' colors{k}]);
    hold on
    figure(2);
    semilogy(1:length(gradSeries), gradSeries / 100, ['.' colors{k}]);
    hold on
end
figure(1);
legend(methods);
figure(2);
legend(methods);
r
end