function SoftICARBFGSLS(method, paramset, HasHHR, N)
%% paramset: 1, qf +VT Parallelization
%%         : 2, constructed R + VT Parallelization
%% Has HHR : Use HHR to gaurantee locking condition or not

%% ARMIJO
num = 5;%1000;
LS_ratios = [1/2, 1/4, 1/16, 1/64];
n = 12;
p = 8;

tab = zeros(num, length(LS_ratios), 8);
for k = 1 : length(LS_ratios)
    clearvars -except num LS_ratios k tab N n p paramset method HasHHR
    for j = 1 : num
        j
        randn('state', j);
        Cs = randn(n, n, N);
        for i = 1 : N
            Cs(:, :, i) = diag(n : -1 : 1) + 0.1 * (Cs(:, :, i) + Cs(:, :, i)');
        end
        X = orth(randn(n, p));
        if(paramset == 2)
            Xp = null(X');
            X = [X, Xp];
        end
        clear('SolverParams');
        SolverParams.method = method;
        SolverParams.LS_ratio1 = LS_ratios(k);
        SolverParams.LS_ratio2 = 1 - LS_ratios(k);
        SolverParams.IsCheckParams = 1;
        SolverParams.DEBUG = 1;
        if(paramset == 1)
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, n, p, HasHHR, 1, SolverParams);
        else
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, n, p, 0, 2, SolverParams);
        end
        % [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funSeries, gradSeries, timeSeries] = TestStieSoftICA(Cs, X, SolverParams);

        tab(j, k, 1) = iter;
        tab(j, k, 2) = nf;
        tab(j, k, 3) = ng;
        tab(j, k, 4) = nR;
        tab(j, k, 5) = nV;
        tab(j, k, 6) = nVp;
        tab(j, k, 7) = nH;
        tab(j, k, 8) = ComTime;
    end
end

dlmwrite([method 'ARMIJO' num2str(N) '_' num2str(paramset) '_' num2str(HasHHR)], tab);

LS_betas = [1-1/2, 1-1/4, 1-1/16, 1-1/64];
tab = zeros(num, length(LS_betas), 8);
if(HasHHR ~= 0 || paramset ~= 1)
%% WOLFE

for k = 1 : length(LS_betas)
    clearvars -except num LS_betas k tab n p N paramset method HasHHR
    for j = 1 : num
        j
        randn('state', j);
        Cs = randn(n, n, N);
        for i = 1 : N
            Cs(:, :, i) = diag(n : -1 : 1) + 0.1 * (Cs(:, :, i) + Cs(:, :, i)');
        end
        X = orth(randn(n, p));
        if(paramset == 2)
            Xp = null(X');
            X = [X, Xp];
        end
        clear('SolverParams');
        SolverParams.method = method;
        SolverParams.LS_beta = LS_betas(k);
        SolverParams.LineSearch_LS = 1;
        SolverParams.IsCheckParams = 1;
        SolverParams.DEBUG = 1;
        if(paramset == 1)
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, n, p, HasHHR, paramset, SolverParams);
        else
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestStieSoftICA(Cs, X, n, p, 0, 2, SolverParams);
        end
        % [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funSeries, gradSeries, timeSeries] = TestStieSoftICA(Cs, X, SolverParams);

        tab(j, k, 1) = iter;
        tab(j, k, 2) = nf;
        tab(j, k, 3) = ng;
        tab(j, k, 4) = nR;
        tab(j, k, 5) = nV;
        tab(j, k, 6) = nVp;
        tab(j, k, 7) = nH;
        tab(j, k, 8) = ComTime;
    end
end
end
dlmwrite([method 'WOLFE' num2str(N) '_' num2str(paramset) '_' num2str(HasHHR)], tab);
end