
p = 500; r = 2; n = 50;

num = 500;

mus = logspace(-8, 1, 6);
table1 = zeros(num, length(mus) + 1);
table2 = zeros(num, length(mus) + 1);
zeroeps = 0.005;
epsilons = [1e-6];

for h = 1 : num

    seed = h;
    rand('state', seed);
    randn('state', seed);

    Q = zeros(p, 2);
    Q(1:10, 1) = 1 /sqrt(10);
    Q(11:20, 2) = 1 /sqrt(10);
    Q = [Q, randn(p, p - r)];
    [Q, ~] = qr(Q);
    D = diag([400, 300, ones(1, 498)]);
    Sigma = Q * D * Q';

    B = mvnrnd(zeros(n, p),Sigma)';

    [U, S, V] = svd(B, 0);
    D = diag(S(1:r, 1:r));
    Dsq = D.^2;

    Xinitial = U(:, 1 : r);

    for i = 1 : length(mus)
        X = Xinitial;
        tic
        for j = 1 : length(epsilons)
            X = TestTestSparsePCA(B, Dsq, X, epsilons(j), mus(i));
        end
        timecost = toc;
        Xopt = X;    
        Temp = zeros(size(Xopt));
        for j = 1 : p
            for k = 1 : r
                if(abs(Xopt(j, k)) > zeroeps)
                    Temp(j, k) = Xopt(j, k);
                end
            end
        end
        for j = 1 : r
            Temp(:, j) = Temp(:, j) / norm(Temp(:, j));
        end
        Xopt = Temp;
        table1(h, i) = Q(:, 1)' * Xopt(:, 1);
        table2(h, i) = Q(:, 2)' * Xopt(:, 2);
    end

    % X' * B * B' * X - diag(Dsq)
    % gam = [0.10, 0.08, 0.06, 0.04, 0.02, 0];%[0, 0.02, 0.04, 0.06, 0.08, 0.10];
    % a1max = norm(B(:, 1));
    % gam = a1max * [0.10, 0.08, 0.06, 0.04, 0.02, 0];
    % gam = a1max * [0.5, 0.4, 0.3, 0.2, 0.1, 0];
    mu=[1:r].^(-1);                     % distinct mu_i
    for i = 1 : 1%length(mus)
        B2T = (B.*B)';
        maxa2 = sqrt(max(sum(B2T)));
        gamma = [maxa2 / 2, maxa2 / 40]
    %     gamma = gam(i)*ones(1,r);
    %     randn('state', seed);
        tic
        XoptGpower=GPower(B',gamma,r,'l1',1,mu);     % Block sparse PCA, l1 penalty
        timecost = toc;
        table1(h, end) = Q(:, 1)' * XoptGpower(:, 1);
        table2(h, end) = Q(:, 2)' * XoptGpower(:, 2);
    end
end
table1 = abs(table1);
table2 = abs(table2);
figure(1); clf

for i = 1 : length(mus)
    subplot(2, size(table1, 2), i);
    hist(table1(:, i), 0:0.01:1);
    xlim([-0.05,1.05]);
    xlabel({['mu:' num2str(mus(i))]; 
        ['per>99%:' num2str(sum(table1(:, i) > 0.99) / size(table1, 1))]});
    hold on
    pause(0.1);
end
subplot(2, size(table1, 2), length(mus) + 1);
hist(table1(:, length(mus) + 1), 0:0.01:1);
xlim([-0.05,1.05]);
xlabel({['gamma in paper']; 
    ['per>99%:' num2str(sum(table1(:, length(mus) + 1) > 0.99) / size(table1, 1))]});
hold on
pause(0.1);


for i = 1 : length(mus)
    subplot(2, size(table2, 2), i + size(table1, 2));
    hist(table2(:, i), 0:0.01:1);
    xlim([-0.05,1.05]);
    xlabel({['mu:' num2str(mus(i))]; 
        ['per>99%:' num2str(sum(table2(:, i) > 0.99) / size(table2, 1))]});
    hold on
    pause(0.1);
end
subplot(2, size(table2, 2), size(table1, 2) + length(mus) + 1);
hist(table2(:, length(mus) + 1), 0:0.01:1);
xlim([-0.05,1.05]);
xlabel({['gamma in paper']; 
    ['per>99%:' num2str(sum(table2(:, length(mus) + 1) > 0.99) / size(table2, 1))]});
hold on
pause(0.1);
