
p = 1000; r = 5; n = 100;

epsilons = [1e-4];
seed = floor(rand()*10000)
seed = 0;
rand('state', seed);
randn('state', seed);

B = randn(p, n);
B = B - repmat((mean(B, 2)), 1, n);
[U, S, V] = svd(B, 0);
D = diag(S(1:r, 1:r));
Dsq = D.^2;

Xinitial = U(:, 1 : r);

zeroeps = 0.005;

% X' * B * B' * X - diag(Dsq)
% mus = logspace(-0.5, 1, 6);
mus = logspace(-6, 1, 6);
figure(1);clf
for i = 1 : length(mus)
    X = Xinitial;
    tic
    for j = 1 : length(epsilons)
        X = TestTestSparsePCA(B, Dsq, X, epsilons(j), mus(i));
    end
    timecost = toc;
    Xopt = X;
    subplot(2, length(mus), i);
    hist(Xopt(abs(Xopt) > zeroeps), -0.5: 0.001: 0.5);
    xlim([-0.5,0.5]);
    
    Temp = zeros(size(Xopt));
    for j = 1 : p
        for k = 1 : r
            if(abs(Xopt(j, k)) > zeroeps)
                Temp(j, k) = Xopt(j, k);
            end
        end
    end
    for j = 1 : r
        Temp(:, j) = Temp(:, j) / norm(Temp(:, j));
    end
    Xopt = Temp;
    
    difftoeye = norm(Xopt' * Xopt - eye(r), 'fro') / sqrt(r);
    
    XtBBtX = (Xopt' * B) * (B' * Xopt);
    refdifftouncorel = norm(XtBBtX - diag(diag(XtBBtX)), 'fro') / norm(XtBBtX, 'fro');
    
    PCAcorrelation =  Xinitial * diag(Dsq) * Xinitial';
    SPCAcorrelation = (Xopt) * diag(Dsq) * (Xopt');
    refcorreltoPCA = norm(PCAcorrelation - SPCAcorrelation, 'fro') / norm(PCAcorrelation, 'fro');
    
    numofnonzero = sum(sum(abs(Xopt) - zeroeps > 0));
    
    xlabel({['mu:' num2str(mus(i))]; 
        ['orth:' num2str(difftoeye)]; 
        ['uncor:' num2str(refdifftouncorel)]; 
        ['rel:' num2str(refcorreltoPCA)]; 
        ['nonzero:' num2str(numofnonzero)]; 
        ['timecost:' num2str(timecost)]});
    hold on
    pause(0.1);
end

% X' * B * B' * X - diag(Dsq)
gam = [0.10, 0.08, 0.06, 0.04, 0.02, 0];%[0, 0.02, 0.04, 0.06, 0.08, 0.10];
mu=[1:r].^(-1);                     % distinct mu_i
for i = 1 : length(mus)
    gamma=gam(i)*ones(1,r);
    tic
    XoptGpower=GPower(B',gamma,r,'l1',1,mu);     % Block sparse PCA, l1 penalty
    timecost = toc;
    [gam(i) sum(sum(abs(XoptGpower) > 0))]
    
    subplot(2, length(mus), i + length(mus));
    hist(XoptGpower(abs(XoptGpower) > 0), -0.5: 0.001: 0.5);
    xlim([-0.5,0.5]);
    
    difftoeye = norm(XoptGpower' * XoptGpower - eye(r), 'fro') / sqrt(r);
    
    XtBBtX = (XoptGpower' * B) * (B' * XoptGpower);
    refdifftouncorel = norm(XtBBtX - diag(diag(XtBBtX)), 'fro') / norm(XtBBtX, 'fro');
    
    PCAcorrelation = Xinitial * diag(Dsq) * Xinitial';
    SPCAcorrelation = (XoptGpower) * diag(Dsq) * (XoptGpower');
    refcorreltoPCA = norm(PCAcorrelation - SPCAcorrelation, 'fro') / norm(PCAcorrelation, 'fro');
    
    numofnonzero = sum(sum(abs(XoptGpower) - zeroeps > 0));
    
    xlabel({['gam:' num2str(gam(i))]; 
        ['orth:' num2str(difftoeye)]; 
        ['uncor:' num2str(refdifftouncorel)]; 
        ['rel:' num2str(refcorreltoPCA)]; 
        ['nonzero:' num2str(numofnonzero)]; 
        ['timecost:' num2str(timecost)]});
    hold on
end
