function test_MIMO_CPP()
clc;close all;

    r = rand();
    r = floor(r * 10000);
    r = 1;
    rand('state', r);
    randn('state', r);
    
    % Brother's parameters
    Tw = 0.002;
    W = 30000; % 30kHz;
    % dt = 8.3333e-6

    % lag milisecond pulse
    % valid lags are anything between -T and T
    % How many lags? (open question)

    % Increasing number of signals causes break down because
    % of interference
    nb = 50; ns = 2;

    delta = 5;

    % Options
    opt.Display = 1;

    fprintf('test for MIMO problem. \n');
    % Compute time samples
    Tw = Tw/2;
    dt = 1/(4*W);
    xt = -Tw:dt:Tw;

    % Compute zero lag pswf functions
    fn = sprintf('./pswf_func_%f_%d_%d.mat', Tw, W, nb);
    if exist(fn, 'file')
        load(fn)
    else
        p0 = pswf(xt/Tw, Tw, W, nb).';
        save(fn, 'p0');
    end


    % Compute correlation matrix for each lag
    % Non-periodic soln
    % If you give it a shift longer than your signal than you get zero
    % zero pad to extend length for applying the biggest lag
    
    lag = -Tw:dt:Tw;
    maxLag = max(lag)/dt;
    pad = ceil(maxLag);
    p0new = [p0; zeros(pad, nb)];
    
    nlags = length(lag);
    C = zeros(nb, nb, nlags);
    for l = 1 : nlags
        pl = fourierShift(p0new.', lag(l), dt).';
        C(:, :, l) = p0new' * pl;
    end
    flag = sprintf('./lags_%f_%d_%d.mat', 2*Tw, W, nb);
    save(flag, 'lag');

    method = 2;

    
    fhandle = @(x)f(x, C, lag, delta);
    gfhandle = @(x)gf(x, C, lag, delta);
    Hesshandle = @(x, eta)Hess(x, eta, C, lag, delta);

    if(method == 1)
        SolverParams.method = 'RBFGS';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.LineSearch_LS = 0;
        SolverParams.LS_alpha = 1e-4;
        SolverParams.LS_beta = 0.999;
        SolverParams.Minstepsize = eps;
        SolverParams.Maxstepsize = 1000;
        SolverParams.LS_ratio = 0.25;
        SolverParams.Initstepsize = 1;
        SolverParams.nu = 1e-6;
        SolverParams.mu = 1;
    elseif(method == 2)
        SolverParams.method = 'LRBFGS';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.LineSearch_LS = 0;
        SolverParams.LS_alpha = 1e-4;
        SolverParams.LS_beta = 0.999;
        SolverParams.Minstepsize = eps;
        SolverParams.Maxstepsize = 1000;
        SolverParams.LS_ratio = 0.25;
        SolverParams.Initstepsize = 1;
        SolverParams.nu = 1e-6;
        SolverParams.mu = 1;
        SolverParams.LengthSY = 4;
    elseif(method == 3)
        SolverParams.method = 'RTRSR1';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.Acceptence_Rho = 0.1;
        SolverParams.Shrinked_tau = 0.25;
        SolverParams.Magnified_tau = 2;
        SolverParams.minimum_Delta = eps;
        SolverParams.maximum_Delta = 1000;
        SolverParams.useRand = 0;
        SolverParams.Min_Inner_Iter = 0;
        SolverParams.Max_Inner_Iter = 1000;
        SolverParams.theta = 1;
        SolverParams.kappa = 0.1;
        SolverParams.initial_Delta = 1;
    elseif(method == 4)
        SolverParams.method = 'LRTRSR1';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.Acceptence_Rho = 0.1;
        SolverParams.Shrinked_tau = 0.25;
        SolverParams.Magnified_tau = 2;
        SolverParams.minimum_Delta = eps;
        SolverParams.maximum_Delta = 1000;
        SolverParams.useRand = 0;
        SolverParams.Min_Inner_Iter = 0;
        SolverParams.Max_Inner_Iter = 1000;
        SolverParams.theta = 1;
        SolverParams.kappa = 0.1;
        SolverParams.initial_Delta = 1;
        SolverParams.LengthSY = 4;
    elseif(method == 5)
        SolverParams.method = 'RSD';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.LineSearch_LS = 0;
        SolverParams.LS_alpha = 1e-4;
        SolverParams.LS_beta = 0.999;
        SolverParams.Minstepsize = eps;
        SolverParams.Maxstepsize = 1000;
        SolverParams.LS_ratio = 0.25;
        SolverParams.Initstepsize = 1;
    elseif(method == 6)
        SolverParams.method = 'RNewton';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.LineSearch_LS = 0;
        SolverParams.LS_alpha = 1e-4;
        SolverParams.LS_beta = 0.999;
        SolverParams.Minstepsize = eps;
        SolverParams.Maxstepsize = 1000;
        SolverParams.LS_ratio = 0.25;
        SolverParams.Initstepsize = 1;
        SolverParams.useRand = 0;
        SolverParams.Min_Inner_Iter = 0;
        SolverParams.Max_Inner_Iter = 1000;
        SolverParams.theta = 1;
        SolverParams.kappa = 0.1;
    elseif(method == 7)
        SolverParams.method = 'RTRSD';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.Acceptence_Rho = 0.1;
        SolverParams.Shrinked_tau = 0.25;
        SolverParams.Magnified_tau = 2;
        SolverParams.minimum_Delta = eps;
        SolverParams.maximum_Delta = 1000;
        SolverParams.useRand = 0;
        SolverParams.Min_Inner_Iter = 0;
        SolverParams.Max_Inner_Iter = 1000;
        SolverParams.theta = 1;
        SolverParams.kappa = 0.1;
        SolverParams.initial_Delta = 1;
    elseif(method == 8)
        SolverParams.method = 'RTRNewton';
        SolverParams.IsCheckParams = 0;
        SolverParams.IsCheckGradHess = 0;
        SolverParams.Stop_Criterion = 2;
        SolverParams.Tolerance = 1e-6;
        SolverParams.Min_Iteration = 0;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1;
        SolverParams.DEBUG = 2;
        SolverParams.Acceptence_Rho = 0.1;
        SolverParams.Shrinked_tau = 0.25;
        SolverParams.Magnified_tau = 2;
        SolverParams.minimum_Delta = eps;
        SolverParams.maximum_Delta = 1000;
        SolverParams.useRand = 0;
        SolverParams.Min_Inner_Iter = 0;
        SolverParams.Max_Inner_Iter = 1000;
        SolverParams.theta = 1;
        SolverParams.kappa = 0.1;
        SolverParams.initial_Delta = 1;
    end



    ManiParams.IsCheckParams = 0;
    ManiParams(1).name = 'Oblique';
    ManiParams(1).m = ns;
    ManiParams(1).n = nb;
    ManiParams(1).ParamSet = 1;
    HasHHR = 0;

    % Initial Condtions
    x1 = randn(nb, ns);
    [x1, ~] = qr(x1, 0);
%     x1 = reshape(x1, nb*ns, 1);

    InitialX.main = x1;

    [output, fv, gfv, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times] = DriverOPT(fhandle, gfhandle, Hesshandle, SolverParams, ManiParams, HasHHR, InitialX); 

    times';
    
    S = p0 * output.main;
    [n, m] = size(S);
    fb = sprintf('./coef_%f_%d_%d.mat', 2*Tw, W, nb);
    B = output.main;
    save(fb, 'B');
    fs = sprintf('./signal_%f_%d_%d.mat', 2*Tw, W, nb);
    save(fs, 'S');
    
    if(opt.Display == 1) 
        h = figure(1);
        hs1 = subplot(2, 1, 1);
        plot(dt*(1:n), S(:,1), 'b')
        set(get(gcf,'CurrentAxes'),'fontsize',14)
        ylabel('s_1','fontsize',14)
        hs2 = subplot(2, 1, 2);
        plot(dt*(1:n), S(:,2), 'b')
        set(get(gcf,'CurrentAxes'),'fontsize',14)
        ylabel('s_2','fontsize',14)    

        h = figure(2);
        [ccf, clags] = xcorr(S(:,1), S(:,2), floor(n/2));
        plot(clags*dt,20*log10(abs(ccf)))
        axis([-Tw Tw min(20*log10(abs(ccf))) 0])
        set(gca,'fontsize',14)
        title('cross-correlation between s_1 and s_2','fontsize',14)
        xlabel('\tau time lag(s)','fontsize',14);ylabel('20log_{10}(|r_{1,2}(\tau)|)','fontsize',14);
%         saveas(h,'../images/opt3/newcostfunc_4signals/cross_corr_s1_s2.png');
%         close(h)
        
        h = figure(3);
        [acf2, aclags] = xcorr(S(:,1), floor(n/2));
        plot(aclags*dt,20*log10(abs(acf2)))
        axis([-Tw Tw -30 0])
        set(gca,'fontsize',14)
        title('auto-correlation of s_1','fontsize',14)
        xlabel('\tau time lag(s)','fontsize',14);ylabel('20log_{10}(|r_{1,1}(\tau)|)','fontsize',14);
%         saveas(h,'../images/opt3/newcostfunc_4signals/auto_corr_s1.png');
%         close(h)
        
        h = figure(4);
        [acf2, aclags] = xcorr(S(:,2), floor(n/2));
        plot(aclags*dt,20*log10(abs(acf2)))
        axis([-Tw Tw -30 0])
        set(gca,'fontsize',14)
        title('auto-correlation of s_2','fontsize',14)
        xlabel('\tau time lag(s)','fontsize',14);ylabel('20log_{10}(|r_{2,2}(\tau)|)','fontsize',14);
%         saveas(h,'../images/opt3/newcostfunc_4signals/auto_corr_s2.png');
%         close(h)
    end
end

%% Objects
function [output, x] = f(x, C, lag, delta)
    % Cost Function
    [nb,  ns] = size(x.main);
    N = size(C, 3);
    I1 = 0;
    
%     x.CU = zeros(nb, ns);
%     x.UtCU = zeros(ns, ns, N);
    
    % Neighborhood around tau = 0
    dl = ceil(N/2)-delta;
    du = ceil(N/2)+delta;
    
    a = lag(1); b = lag(dl);
    for i = 1 : dl
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        f = norm(tmp2,'fro')^2;
        
        if(i == 1 || i == dl)
            I1 = I1 + ((b - a) / (N - 1)) * (f / 2);
        else
            I1 = I1 + ((b - a) / (N - 1)) * f;
        end
    end
    
    a = lag(dl); b = lag(du);
    for i = dl : du
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        fO = norm((triu(tmp2,1) + tril(tmp2,-1)),'fro')^2;
        
        if(i == dl || i == du)
            I1 = I1 + ((b - a) / (N - 1)) * (fO / 2);
        else
            I1 = I1 + ((b - a) / (N - 1)) * fO;
        end
    end
    
    a = lag(du); b = lag(N);
    for i = du : N
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        f = norm(tmp2,'fro')^2;
        
        if(i == du || i == N)
            I1 = I1 + ((b - a) / (N - 1)) * (f / 2);
        else
            I1 = I1 + ((b - a) / (N - 1)) * f;
        end
    end
    output = I1;
end

function [output, x] = gf(x, C, lag, delta)
    % Euclidean Gradient
    [nb, ns] = size(x.main);
    N = size(C, 3);
    Q1 = zeros(nb, ns);
    
    dl = ceil(N/2)-delta;
    du = ceil(N/2)+delta;
    
    
%     x.CtU = zeros(nb, ns, N);
    
%     if(~isfield(x, 'CU'))
%         for i = 1 : N
%             x.CU(:, :, i) = C(:, :, i) * x.main;
%         end
%     end
%     
%     if(~isfield(x, 'UtCU'))
%         for i = 1 : N
%             x.UtCU(:, :, i) = x.main' * x.CU(:, :, i);
%         end
%     end
    
    a = lag(1); b = lag(dl);
    for i = 1 : dl
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        tmp3 = C(:, :, i)' * x.main;
        gf = (tmp1 * tmp2') + (tmp3 * tmp2);
        
        if(i == 1 || i == dl)
            Q1 = Q1 + ((b - a) / (N - 1)) * (gf / 2);
        else
            Q1 = Q1 + ((b - a) / (N - 1)) * gf;
        end
    end
    
    a = lag(dl); b = lag(du);
    for i = dl : du
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        tmp3 = C(:, :, i)' * x.main;
        gfO = (tmp1 * (triu(tmp2 ,1) + tril(tmp2 ,-1))') + (tmp3 * (triu(tmp2,1) + tril(tmp2,-1)));
        
        if(i == dl || i == du)
            Q1 = Q1 + ((b - a) / (N - 1)) * (gfO / 2);
        else
            Q1 = Q1 + ((b - a) / (N - 1)) * gfO;
        end
    end
    
    a = lag(du); b = lag(N);
    for i = du : N
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        tmp3 = C(:, :, i)' * x.main;
        gf = (tmp1 * tmp2') + (tmp3 * tmp2);
        
        if(i == du || i == N)
            Q1 = Q1 + ((b - a) / (N - 1)) * (gf / 2);
        else
            Q1 = Q1 + ((b - a) / (N - 1)) * gf;
        end
    end

    output.main = 2 * Q1;
end

function [output, x] = Hess(x, eta, C, lag, delta)
    % Euclidean Hessian
    [nb, ns] = size(x.main);
    N = size(C, 3);
    Q2 = zeros(nb, ns);

    dl = ceil(N/2)-delta;
    du = ceil(N/2)+delta;
    
%     if(~isfield(x, 'CU'))
%         for i = 1 : N
%             x.CU(:, :, i) = C(:, :, i) * x.main;
%         end
%     end
%     
%     if(~isfield(x, 'UtCU'))
%         for i = 1 : N
%             x.UtCU(:, :, i) = x.main' * x.CU(:, :, i);
%         end
%     end
%     
%     if(~isfield(x, 'CtU'))
%         for i = 1 : N
%             x.CtU(:, :, i) = C(:, :, i)' * x.main;
%         end
%     end
    
    a = lag(1); b = lag(dl);
    for i = 1 : dl
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        tmp3 = C(:, :, i)' * x.main;
        tmp4 = C(:, :, i) * eta.main;
        tmp5 = C(:, :, i)' * eta.main;
        tmp6 = eta.main' * tmp1;
        tmp7 = x.main' * tmp4;
        
        Dgf = (tmp4 * tmp2') + (tmp1 * tmp6') + (tmp1 * tmp7') + ...
            (tmp5 * tmp2) + (tmp3 * tmp6) + (tmp3 * tmp7);
        
        if(i == 1 || i == dl)
            Q2 = Q2 + ((b - a) / (N-1)) * (Dgf / 2);
        else
            Q2 = Q2 + ((b - a) / (N-1)) * Dgf;
        end
    end
    
    a = lag(dl); b = lag(du);
    for i = dl : du
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        tmp3 = C(:, :, i)' * x.main;
        tmp4 = C(:, :, i) * eta.main;
        tmp5 = C(:, :, i)' * eta.main;
        tmp6 = eta.main' * tmp1;
        tmp7 = x.main' * tmp4;
        
        DgfO = (tmp4 * (triu(tmp2,1) + tril(tmp2,-1))') + (tmp1 * (triu(tmp6,1) + tril(tmp6,-1))') + ...
            (tmp1 * (triu(tmp7,1) + tril(tmp7,-1))') + (tmp5 * (triu(tmp2,1) + tril(tmp2,-1))) + ...
            (tmp3 * (triu(tmp6,1) + tril(tmp6,-1))) + (tmp3 * (triu(tmp7,1) + tril(tmp7,-1)));

        if(i == dl || i == du)
            Q2 = Q2 + ((b - a) / (N-1)) * (DgfO / 2);
        else
            Q2 = Q2 + ((b - a) / (N-1)) * DgfO;
        end
    end
    
    a = lag(du); b = lag(N);
    for i = du : N
        tmp1 = C(:, :, i) * x.main;
        tmp2 = x.main' * tmp1;
        tmp3 = C(:, :, i)' * x.main;
        tmp4 = C(:, :, i) * eta.main;
        tmp5 = C(:, :, i)' * eta.main;
        tmp6 = eta.main' * tmp1;
        tmp7 = x.main' * tmp4;
        
        Dgf = (tmp4 * tmp2') + (tmp1 * tmp6') + (tmp1 * tmp7') + ...
            (tmp5 * tmp2) + (tmp3 * tmp6) + (tmp3 * tmp7);
        
        if(i == du || i == N)
            Q2 = Q2 + ((b - a) / (N-1)) * (Dgf / 2);
        else
            Q2 = Q2 + ((b - a) / (N-1)) * Dgf;
        end
    end 
    output.main = 2 * Q2;
end
