
#include "RSD.h"

RSD::RSD(const Problem *prob, const Variable *initialx)
{
	Initialization(prob, initialx);
};

void RSD::SetProbX(const Problem *prob, const Variable *initialx)
{
	SolversLS::SetProbX(prob, initialx);
	prob->SetUseGrad(true);
	prob->SetUseHess(false);
};

void RSD::SetDefaultParams()
{
	SolversLS::SetDefaultParams();
	SolverName.assign("RSD");
};

void RSD::GetSearchDir(void)
{
	Mani->ScaleTimesVector(x1, -1, gf1, eta1);
};

void RSD::InitialStepSize(void)
{
	if (iter == 0)
		stepsize = Initstepsize;
	else
	{
		stepsize = 1.01 * 2.0 * (f1 - fpre) / initialslope;
		stepsize = (stepsize < std::numeric_limits<double>::epsilon()) ? Initstepsize / ngf : stepsize;
	}
};
